﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.ServiceModel;
using System.Net;
using System.Xml.Linq;
using System.Windows.Media.Imaging;

namespace CallingServices
{
    public partial class Page : UserControl
    {
        public Page()
        {
            InitializeComponent();
        }

        private void AsmxServiceButton_Click(object sender, RoutedEventArgs e)
        {
            BasicHttpBinding bind = new BasicHttpBinding();
            EndpointAddress endpoint = new EndpointAddress("http://localhost:50042/CallingServices_Web/Services/SimpleAsmx.asmx");

            AsmxService.SimpleAsmxSoapClient asmx = new CallingServices.AsmxService.SimpleAsmxSoapClient(bind, endpoint);
            asmx.HelloWorldWithAsmxCompleted += new EventHandler<CallingServices.AsmxService.HelloWorldWithAsmxCompletedEventArgs>(asmx_HelloWorldWithAsmxCompleted);
            asmx.HelloWorldWithAsmxAsync(StringToEmit.Text);
        }

void asmx_HelloWorldWithAsmxCompleted(object sender, CallingServices.AsmxService.HelloWorldWithAsmxCompletedEventArgs e)
{
    OutputString.Text = string.Format("Output from ASMX: {0}", e.Result.ToString());
}

private void WcfServiceButton_Click(object sender, RoutedEventArgs e)
{
    BasicHttpBinding bind = new BasicHttpBinding();
    EndpointAddress endpoint = new EndpointAddress("http://localhost:50042/CallingServices_Web/WcfService.svc");

    WcfServiceRef.WcfServiceClient wcf = new CallingServices.WcfServiceRef.WcfServiceClient(bind, endpoint);
    wcf.HelloWorldFromWcfCompleted += new EventHandler<CallingServices.WcfServiceRef.HelloWorldFromWcfCompletedEventArgs>(wcf_HelloWorldFromWcfCompleted);
    try
    {
        wcf.HelloWorldFromWcfAsync(StringToEmit.Text);
    }
    catch (Exception ex)
    {
        OutputString.Text = ex.Message;
    }
}

void wcf_HelloWorldFromWcfCompleted(object sender, CallingServices.WcfServiceRef.HelloWorldFromWcfCompletedEventArgs e)
{
    try
    {
        OutputString.Text = string.Format("Output from WCF: {0}", e.Result.ToString());
    }
    catch (Exception ex)
    {
        OutputString.Text = ex.Message;
    }
}

        private void RestServiceButton_Click(object sender, RoutedEventArgs e)
        {
            string flickrApi = string.Format("http://api.flickr.com/services/rest/?method=flickr.photos.search&tags={0}&page=1&per_page=5&api_key=YOUR_API_KEY&safe_search=3", StringToEmit.Text);
            WebClient rest = new WebClient();
            rest.DownloadStringCompleted += new DownloadStringCompletedEventHandler(rest_DownloadStringCompleted);
            rest.DownloadStringAsync(new Uri(flickrApi));
        }

        void rest_DownloadStringCompleted(object sender, DownloadStringCompletedEventArgs e)
        {
            // for rest implementation we get raw xml
            // http://farm{farm-id}.static.flickr.com/{server-id}/{id}_{secret}_[mstb].jpg
            
            string data = e.Result;
            string url = string.Empty;

            FlickrImages.Children.Clear();

            XDocument doc = XDocument.Parse(e.Result);
            var photos = from results in doc.Descendants("photo")
                        select new
                        {
                            id = results.Attribute("id").Value.ToString(),
                            farm = results.Attribute("farm").Value.ToString(),
                            server = results.Attribute("server").Value.ToString(),
                            secret = results.Attribute("secret").Value.ToString()
                        };

            foreach (var photo in photos)
            {
                url = string.Format("http://farm{0}.static.flickr.com/{1}/{2}_{3}_m.jpg", photo.farm, photo.server, photo.id, photo.secret);
                Image img = new Image();
                img.Stretch = Stretch.Fill;
                img.Margin = new Thickness(10);
                img.Source = new BitmapImage(new Uri(url));
                FlickrImages.Children.Add(img);
            }

            OutputString.Text = string.Format("Flickr pictures for {0} shown below", StringToEmit.Text);
        }
    }
}
